#import <MessageUI/MessageUI.h>

#define POPLISTVIEW_SCREENINSET 30.
#define POPLISTVIEW_BUTTONINSET 10.
#define POPLISTVIEW_HEADER_HEIGHT 50.
#define POPLISTVIEW_FOOTER_HEIGHT 50.
#define RADIUS 5.
#define FIRST_USE_WAIT_TIME 4.

#define ADDRESSBOOK_DENIED_ACCESS_ALERT_TITLE @"Don't see any contacts?"
#define ADDRESSBOOK_DENIED_ACCESS_ALERT_MSG  @"To share this app with your friends, we need access to your address book. Please go to Settings / Privacy / Contacts and enable access for this app."
#define INVITE_SELECT_SOME_FRIENDS_MSG @"Please select a few friends first"
#define NO_NETWORK_COVERAGE_ERROR_ALERT_TITLE @"Sorry!"
#define NO_NETWORK_COVERAGE_ERROR_ALERT_MSG @"No data coverage. Please check your settings"

#define INITIAL_ADDRESSBOOK_UPLOAD_SIZE 200

@protocol HKMInviteDelegate;
@interface HKMInviteView : UIView <UITableViewDataSource, UITableViewDelegate, MFMessageComposeViewControllerDelegate, UIAlertViewDelegate>
{
    UITableView *_tableView;
    UIButton *_sendButton;
    NSString *_title;
    NSTimer *_aTimer;
    int _lastInviteCount;
    BOOL _useVirtualNumber;
    NSString *_inviterName;
}

@property (nonatomic, assign) id<HKMInviteDelegate> delegate;

+ (void) activateWithAppKey:(NSString *)key;
+ (void) activateWithAppKey:(NSString *)key customParam: (NSString *) name;
- (id)initWithTitle:(NSString *)aTitle sendBtnLabel:(NSString *)sendBtnLabel view:(UIView *)view useVirtualNumber:(BOOL)virtualNumber;
- (id)initWithTitle:(NSString *)aTitle sendBtnLabel:(NSString *)sendBtnLabel view:(UIView *)view useVirtualNumber:(BOOL)virtualNumber inviterName:(NSString *)name;
- (void)showInView:(UIView *)aView animated:(BOOL)animated;

@end

@protocol HKMInviteDelegate <NSObject>
- (void)invitedCount:(NSInteger)count;
- (void)inviteCancelled;
@end